﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Security.Principal;
using System.Text;

namespace SlnMesnac.RfidUpload.Model
{
    [SugarTable("UPLOAD_RECORD")]
    public class UploadRecord
    { 
        // 该特性指定此属性对应数据库表中的 id 列
        // IsIdentity = true 表示该列是自增列
        // IsPrimaryKey = true 表示该列是主键
        [SugarColumn(ColumnName = "id", IsIdentity = true, IsPrimaryKey = true)]
        public int Id { get; set; }

        // 该特性指定此属性对应数据库表中的 ffjhNo 列，用于存储封发计划编号
        [SugarColumn(ColumnName = "ffjhNo")]
        public string FfjhNo { get; set; }

        // 该特性指定此属性对应数据库表中的 opBatch 列，用于存储封发计划使用序号
        [SugarColumn(ColumnName = "opBatch")]
        public string OpBatch { get; set; }

        // 该特性指定此属性对应数据库表中的 ffjhscrq 列，用于存储封发计划生成日期
        [SugarColumn(ColumnName = "ffjhscrq")]
        public string Ffjhscrq { get; set; }

        // 该特性指定此属性对应数据库表中的 stationOrgCode 列，用于存储机构代码
        [SugarColumn(ColumnName = "stationOrgCode")]
        public string StationOrgCode { get; set; }

        // 该特性指定此属性对应数据库表中的 stationOrgName 列，用于存储机构名称
        [SugarColumn(ColumnName = "stationOrgName")]
        public string StationOrgName { get; set; }

        // 该特性指定此属性对应数据库表中的 strList 列，用于存储 RFID 列表（以 JSON 字符串形式存储）
        [SugarColumn(ColumnName = "strList")]
        public string StrList { get; set; }

        // 该特性指定此属性对应数据库表中的 isSuccess 列，用于表示上传状态
        // DefaultValue = "0" 表示该列的默认值为 0，0 代表上传失败，1 代表上传成功
        [SugarColumn(ColumnName = "isSuccess", DefaultValue = "0")]
        public int IsSuccess { get; set; }

        //时间
        [SugarColumn(ColumnName = "uploadTime")]
        public string UploadTime { get; set; }
    }
}
