﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SlnMesnac.RfidUpload.UI.TempData
{

    /// <summary>
    /// 存放系统临时数据
    /// 暂时只存储新容器入库校验界面的送货单号列表数据
    /// </summary>
    public  class SysData
    {
        #region 单例实现
        private static readonly SysData lazy = new SysData();
        public static SysData Instance
        {
            get
            {
                return lazy;
            }
        }
        #endregion


        public List<newContainerInCheckData> trackNoList = new List<newContainerInCheckData>();
    }


    /// <summary>
    /// 新容器入库校验界面的送货单号列表数据
    /// </summary>
    public class newContainerInCheckData 
    {
        /// <summary>
        /// 调拨单号
        /// </summary>
        public string dbdh { get; set; }

        /// <summary>
        /// 送货单号
        /// </summary>
        public string trackNo { get; set; }

        /// <summary>
        /// 开始号段
        /// </summary>
        public string rqtmStart { get; set; }


        /// <summary>
        /// 结束号段
        /// </summary>
        public string rqtmEnd { get; set; }

        /// <summary>
        /// 添加时间
        /// </summary>
        public DateTime time { get; set; }

    }

}
